# DrudeForce Class Reference

This class implements forces that are specific to Drude oscillators. More...

Inheritance diagram for DrudeForce:

List of all members.

## Public Member Functions

def | getNumParticles
| getNumParticles(self) -> int
def | getNumScreenedPairs
| getNumScreenedPairs(self) -> int
def | addParticle
| addParticle(self, int particle, int particle1, int particle2, int particle3, int particle4, double charge, double polarizability, double aniso12, double aniso34) -> int
def | getParticleParameters
| getParticleParameters(self, int index)
def | setParticleParameters
| setParticleParameters(self, int index, int particle, int particle1, int particle2, int particle3, int particle4, double charge, double polarizability, double aniso12, double aniso34)
def | addScreenedPair
| addScreenedPair(self, int particle1, int particle2, double thole) -> int
def | getScreenedPairParameters
| getScreenedPairParameters(self, int index)
def | setScreenedPairParameters
| setScreenedPairParameters(self, int index, int particle1, int particle2, double thole)
def | updateParametersInContext
| updateParametersInContext(self, Context context)
def | __init__
| __init__(self) -> DrudeForce __init__(self, DrudeForce other) -> DrudeForce
def | __del__
| __del__(self)

## Public Attributes

| this

## Detailed Description

This class implements forces that are specific to Drude oscillators.

There are two distinct forces it applies: an anisotropic harmonic force connecting each Drude particle to its parent particle; and a screened Coulomb interaction between specific pairs of dipoles. The latter is typically used between closely bonded particles whose Coulomb interaction would otherwise be fully excluded.

To use this class, create a DrudeForce object, then call addParticle() once for each Drude particle in the System to define its parameters. After a particle has been added, you can modify its force field parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext(). Likewise, call addScreenedPair() for each pair of dipoles (each dipole consisting of a Drude particle and its parent) that should be computed.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self) -> DrudeForce __init__(self, DrudeForce other) -> DrudeForce

Create a DrudeForce.

def addParticle | ( |  | self,
|  |  | args |
| ) |  |  |

addParticle(self, int particle, int particle1, int particle2, int particle3, int particle4, double charge, double polarizability, double aniso12, double aniso34) -> int

Add a Drude particle to which forces should be applied.

Parameters:

  | particle | the index within the System of the Drude particle
  | particle1 | the index within the System of the particle to which the Drude particle is attached
  | particle2 | the index within the System of the second particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso12 will be ignored.
  | particle3 | the index within the System of the third particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | particle4 | the index within the System of the fourth particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | charge | The charge on the Drude particle
  | polarizability | The isotropic polarizability
  | aniso12 | The scale factor for the polarizability along the direction defined by particle1 and particle2
  | aniso34 | The scale factor for the polarizability along the direction defined by particle3 and particle4

def addScreenedPair | ( |  | self,
|  |  | args |
| ) |  |  |

addScreenedPair(self, int particle1, int particle2, double thole) -> int

Add an interaction to the list of screened pairs.

Parameters:

  | particle1 | the index within this Force of the first particle involved in the interaction
  | particle2 | the index within this Force of the second particle involved in the interaction
  | thole | the Thole screening factor

def getNumParticles | ( |  | self | ) |

getNumParticles(self) -> int

Get the number of particles for which force field parameters have been defined.

def getNumScreenedPairs | ( |  | self | ) |

getNumScreenedPairs(self) -> int

Get the number of special interactions that should be calculated differently from other interactions.

def getParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getParticleParameters(self, int index)

Get the parameters for a Drude particle.

Parameters:

  | index | the index of the Drude particle for which to get parameters
  | particle | the index within the System of the Drude particle
  | particle1 | the index within the System of the particle to which the Drude particle is attached
  | particle2 | the index within the System of the second particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso12 will be ignored.
  | particle3 | the index within the System of the third particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | particle4 | the index within the System of the fourth particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | charge | The charge on the Drude particle
  | polarizability | The isotropic polarizability
  | aniso12 | The scale factor for the polarizability along the direction defined by particle1 and particle2
  | aniso34 | The scale factor for the polarizability along the direction defined by particle3 and particle4

def getScreenedPairParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getScreenedPairParameters(self, int index)

Get the force field parameters for screened pair.

Parameters:

  | index | the index of the pair for which to get parameters
  | particle1 | the index within this Force of the first particle involved in the interaction
  | particle2 | the index within this Force of the second particle involved in the interaction
  | thole | the Thole screening factor

def setParticleParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setParticleParameters(self, int index, int particle, int particle1, int particle2, int particle3, int particle4, double charge, double polarizability, double aniso12, double aniso34)

Set the parameters for a Drude particle.

Parameters:

  | index | the index of the Drude particle for which to set parameters
  | particle | the index within the System of the Drude particle
  | particle1 | the index within the System of the particle to which the Drude particle is attached
  | particle2 | the index within the System of the second particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso12 will be ignored.
  | particle3 | the index within the System of the third particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | particle4 | the index within the System of the fourth particle used for defining anisotropic polarizability. This may be set to -1, in which case aniso34 will be ignored.
  | charge | The charge on the Drude particle
  | polarizability | The isotropic polarizability
  | aniso12 | The scale factor for the polarizability along the direction defined by particle1 and particle2
  | aniso34 | The scale factor for the polarizability along the direction defined by particle3 and particle4

def setScreenedPairParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setScreenedPairParameters(self, int index, int particle1, int particle2, double thole)

Set the force field parameters for screened pair.

Parameters:

  | index | the index of the pair for which to get parameters
  | particle1 | the index within this Force of the first particle involved in the interaction
  | particle2 | the index within this Force of the second particle involved in the interaction
  | thole | the Thole screening factor

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(self, Context context)

Update the particle and screened pair parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() and setScreenedPairParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. It can be used to modify the numeric parameters associated with a particle or screened pair (polarizability, thole, etc.), but not the identities of the particles they involve. It also cannot be used to add new particles or screenedPairs, only to change the parameters of existing ones.

## Member Data Documentation

this

The documentation for this class was generated from the following file:

- openmm.py